Package org.bukkit.event.entity

# Class EntityDeathEvent

java.lang.Object
org.bukkit.event.Event
org.bukkit.event.entity.EntityEvent
org.bukkit.event.entity.EntityDeathEvent

All Implemented Interfaces:
  `Cancellable`

Direct Known Subclasses:
  `PlayerDeathEvent`

public class EntityDeathEvent extends EntityEvent implements Cancellable
Thrown whenever a LivingEntity dies

## Nested Class Summary

## Nested classes/interfaces inherited from class org.bukkit.event.Event

`Event.Result`

## Field Summary

### Fields inherited from class org.bukkit.event.entity.EntityEvent

`entity`

## Constructor Summary

Constructors
Constructor
Description
`EntityDeathEvent(@NotNull LivingEntity entity, @NotNull List<ItemStack> drops)`
`EntityDeathEvent(@NotNull LivingEntity what, @NotNull List<ItemStack> drops, int droppedExp)`

## Method Summary

Modifier and Type
Method
Description
`Sound`
`getDeathSound()`
Get the sound that the entity makes when dying
`SoundCategory`
`getDeathSoundCategory()`
Get the sound category that the death sound should play in
`float`
`getDeathSoundPitch()`
Get the pitch that the death sound will play with.
`float`
`getDeathSoundVolume()`
Get the volume that the death sound will play at.
`int`
`getDroppedExp()`
Gets how much EXP should be dropped from this death.
`@NotNull List<ItemStack>`
`getDrops()`
Gets all the items which will drop when the entity dies
`@NotNull LivingEntity`
`getEntity()`
Returns the Entity involved in this event
`static @NotNull HandlerList`
`getHandlerList()`
`@NotNull HandlerList`
`getHandlers()`
`double`
`getReviveHealth()`
Get the amount of health that the entity should revive with after cancelling the event.
`boolean`
`isCancelled()`
Gets the cancellation state of this event.
`void`
`setCancelled(boolean cancel)`
Sets the cancellation state of this event.
`void`
`setDeathSound(Sound sound)`
Set the sound that the entity makes when dying
`void`
`setDeathSoundCategory(SoundCategory soundCategory)`
Set the sound category that the death sound should play in.
`void`
`setDeathSoundPitch(float pitch)`
GSetet the pitch that the death sound should play with.
`void`
`setDeathSoundVolume(float volume)`
Set the volume the death sound should play at.
`void`
`setDroppedExp(int exp)`
Sets how much EXP should be dropped from this death.
`void`
`setReviveHealth(double reviveHealth)`
Set the amount of health that the entity should revive with after cancelling the event.
`void`
`setShouldPlayDeathSound(boolean playDeathSound)`
Set whether or not the death sound should play when the entity dies.
`boolean`
`shouldPlayDeathSound()`
Whether or not the death sound should play when the entity dies.

### Methods inherited from class org.bukkit.event.entity.EntityEvent

`getEntityType`

### Methods inherited from class org.bukkit.event.Event

`callEvent, getEventName, isAsynchronous`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### EntityDeathEvent

public EntityDeathEvent(@NotNull @NotNull LivingEntity entity, @NotNull @NotNull List<ItemStack> drops)

### EntityDeathEvent

public EntityDeathEvent(@NotNull @NotNull LivingEntity what, @NotNull @NotNull List<ItemStack> drops, int droppedExp)

## Method Details

### getEntity

@NotNull public @NotNull LivingEntity getEntity()
Description copied from class: `EntityEvent`
Returns the Entity involved in this event

Overrides:
  `getEntity` in class `EntityEvent`
Returns:
  Entity who is involved in this event

### getDroppedExp

public int getDroppedExp()
Gets how much EXP should be dropped from this death.

This does not indicate how much EXP should be taken from the entity in question, merely how much should be created after its death.

Returns:
  Amount of EXP to drop.

### setDroppedExp

public void setDroppedExp(int exp)
Sets how much EXP should be dropped from this death.

This does not indicate how much EXP should be taken from the entity in question, merely how much should be created after its death.

Parameters:
  `exp` - Amount of EXP to drop.

### getDrops

@NotNull public @NotNull List<ItemStack> getDrops()
Gets all the items which will drop when the entity dies

Returns:
  Items to drop when the entity dies

### getHandlers

@NotNull public @NotNull HandlerList getHandlers()

Specified by:
  `getHandlers` in class `Event`

### getHandlerList

@NotNull public static @NotNull HandlerList getHandlerList()

### isCancelled

public boolean isCancelled()
Description copied from interface: `Cancellable`
Gets the cancellation state of this event. A cancelled event will not be executed in the server, but will still pass to other plugins

Specified by:
  `isCancelled` in interface `Cancellable`
Returns:
  true if this event is cancelled

### setCancelled

public void setCancelled(boolean cancel)
Description copied from interface: `Cancellable`
Sets the cancellation state of this event. A cancelled event will not be executed in the server, but will still pass to other plugins.

Specified by:
  `setCancelled` in interface `Cancellable`
Parameters:
  `cancel` - true if you wish to cancel this event

### getReviveHealth

public double getReviveHealth()
Get the amount of health that the entity should revive with after cancelling the event. Set to the entity's max health by default.

Returns:
  The amount of health

### setReviveHealth

public void setReviveHealth(double reviveHealth) throws IllegalArgumentException
Set the amount of health that the entity should revive with after cancelling the event. Revive health value must be between 0 (exclusive) and the entity's max health (inclusive).

Parameters:
  `reviveHealth` - The amount of health
Throws:
  `IllegalArgumentException` - Thrown if the health is <= 0 or > max health

### shouldPlayDeathSound

public boolean shouldPlayDeathSound()
Whether or not the death sound should play when the entity dies. If the event is cancelled it does not play!

Returns:
  Whether or not the death sound should play. Event is called with this set to false if the entity is silent.

### setShouldPlayDeathSound

public void setShouldPlayDeathSound(boolean playDeathSound)
Set whether or not the death sound should play when the entity dies. If the event is cancelled it does not play!

Parameters:
  `playDeathSound` - Enable or disable the death sound

### getDeathSound

@Nullable public Sound getDeathSound()
Get the sound that the entity makes when dying

Returns:
  The sound that the entity makes

### setDeathSound

public void setDeathSound(@Nullable Sound sound)
Set the sound that the entity makes when dying

Parameters:
  `sound` - The sound that the entity should make when dying

### getDeathSoundCategory

@Nullable public SoundCategory getDeathSoundCategory()
Get the sound category that the death sound should play in

Returns:
  The sound category

### setDeathSoundCategory

public void setDeathSoundCategory(@Nullable SoundCategory soundCategory)
Set the sound category that the death sound should play in.

Parameters:
  `soundCategory` - The sound category

### getDeathSoundVolume

public float getDeathSoundVolume()
Get the volume that the death sound will play at.

Returns:
  The volume the death sound will play at

### setDeathSoundVolume

public void setDeathSoundVolume(float volume)
Set the volume the death sound should play at. If the event is cancelled this will not play the sound!

Parameters:
  `volume` - The volume the death sound should play at

### getDeathSoundPitch

public float getDeathSoundPitch()
Get the pitch that the death sound will play with.

Returns:
  The pitch the death sound will play with

### setDeathSoundPitch

public void setDeathSoundPitch(float pitch)
GSetet the pitch that the death sound should play with.

Parameters:
  `pitch` - The pitch the death sound should play with